const urlBase = document.location.protocol + '//' +  document.location.host + '/panther';
	export const conf = {
		default_machine: 'elettra',
		machineList: ['elettra', 'elettra2', 'fermi', 'esrf','nsls2'],
		tooltipAppNormal: urlBase+'/spa/index.html',
		tooltipApp: document.location.search.indexOf('demo')>-1? './magnetdemo.html': urlBase+'/spa/index.html',
		rchan: urlBase+"/rchan.php?json&valueOnly&src=",
		stateLabelColor: {'ON':'green','OFF':'white','CLOSED':'white','OPENED':'green','INSERT':'white','EXTRACT':'green','MOVING':'LightBlue','STANDBY':'yellow','FAULT':'red','INIT':'beige','RUNNING':'DarkGreen','ALARM':'orange','DISABLE':'magenta','UNKNOWN':'grey'},
		stateSrcUrl: urlBase+'/updater.php?read&filename=1000.ps.src',
		stateUrl: urlBase+'/updater.php?read&filename=1000.ps',
		vlvSrcUrl: urlBase+'/updater.php?read&filename=1000.vlv.src',
		vlvUrl: urlBase+'/updater.php?read&filename=1000.vlv',
		compdb: '<components_database_url>',
		bstmap: {'base': 'some BST'}),
		modes: ['fast', 'plus', 'premium'],
		bpmSrcUrl: urlBase+'/bpm.php?src',
		bpmUrl: urlBase+'/bpm.php',
		bpmFactor: {a: 1000, b: 100, c: 10},
		blmSrcUrl: urlBase+'/blm.php?src',
		blmUrl: urlBase+'/blm.php'
	};
