# PAnTHer

Particle Accelerator on THreeJS (PAnTHer) is a model of particle accelerators

A live demo is available at this page: 
https://luciozambon.altervista.org/app/panther.php

A short video introduction is available at this page: 
https://www.youtube.com/watch?v=53zyVab37rg

## Installation
- Install JQuery and JQuery UI from https://jquery.com/
- Install Hammer.js from https://hammerjs.github.io/
- Install svg-pan-zoom from https://github.com/bumbu/svg-pan-zoom
- Create a lattice file in JSON format according to the specifications:
https://gitlab.elettra.eu/puma/client/panther/-/raw/master/panther_lattice.json
for example:
https://gitlab.elettra.eu/puma/client/panther/-/raw/master/elettra_lattice.json
- create a component bundle for 3D using component.php?machine=<your_machine>&save and a coponent bundle for 2D using component.php?machine=<your_machine>&2d&save
- edit file panther_conf.js, panther.php and panther2d.php and adjust according to your setup (e.g. modify the path of JQuery according to your installation)
